/*category   Ardujino application
 *package    WiFi LED ON OFF Switch
 *author     Ichiro Shirasaka
 *copyright  2017 Ichiro Shirasaka All Rights Reserved
 *version    1.0*/
#include <WiFi.h>

const char* ssid = "Input SSID";
const char* password = "Input Password";

WiFiServer server(80);

void setup()
{
    Serial.begin(115200);
    pinMode(2, OUTPUT);      // set the LED pin mode

    delay(10);

    // We start by connecting to a WiFi network
    Serial.println();
    Serial.println();
    Serial.print("Connecting to ");
    Serial.println(ssid);

    WiFi.begin(ssid, password);

    while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
    }

    Serial.println("");
    Serial.println("WiFi connected.");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
    
    server.begin();

}

int value = 0;
String html1 = "<!DOCTYPE html><html lang='ja'><head><meta charset='UTF-8'>";
String html2 = "<style>input {margin:8px;width:100px;}div {font-size:16pt;text-align:center;width:250px;border:groove 16px green;}</style>";
String html3 = "<title>Color LED Controller</title></head>";
String html4 = "<body><div><p>LED Controller</p><form method='get'>";
String html5 = "<input type='submit' name='onl' value='ON' /><input type='submit' name='off' value='OFF' /></form>";
String html = html1 + html2 + html3 + html4 + html5 + "</div></body></html>";

void loop(){
 WiFiClient client = server.available();     // listen for incoming clients

  if (client) {                              // if you get a client,
    Serial.println("New Client.");          // print a message out the serial port
    while (client.connected()) {             // loop while the client's connected
      if (client.available()) {              // if there's bytes to read from the client,
        String line = client.readStringUntil('\r');
        Serial.print(line);
        // Check to see if the client request was "GET /H" or "GET /L":
        if (line.indexOf("GET /?on")) {
          digitalWrite(2, HIGH);               // GET /H turns the LED on
        }
        if (line.indexOf("GET /?off")) {
          digitalWrite(2, LOW);                // GET /L turns the LED off
        }
        // wait for end of client's request, that is marked with an empty line
        if (line.length() == 1 && line[0] == '\n'){
          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
          // and a content-type so the client knows what's coming, then a blank line:
          client.println("HTTP/1.1 200 OK");
          client.println("Content-type:text/html");
          client.println();
          // the content of the HTTP response follows the header:
          client.print(html);
          client.println();
          Serial.println(html);
          // break out of the while loop:
          break;
        }
      }
    }
    delay(1); // give the web browser time to receive the data
    // close the connection:
    client.stop();
    Serial.println("Client Disconnected.");
  }
}
