﻿'''
Thermometer
#Date: 2017 8/14
#Auther:Ichiro Shirasaka
'''
from machine import Pin, ADC, SPI, Timer

# Initialize SPI
spi = SPI(1, baudrate=10000000, polarity=0, phase=0, sck=Pin(16), mosi=Pin(17), miso=Pin(25))

d3 = Pin(4, Pin.IN, Pin.PULL_UP)
d4 = Pin(13, Pin.OUT)
d4.value(0)

led_n = 0
led_col = 0x0008

# LED Pattern
ledptn = (
0xc0, 0xf9, 0xa4, 0xb0, 0x99, 0x92, 0x82, 0xf8,
0x80, 0x90, 0x88, 0x83, 0xc6, 0x1a, 0x86, 0x8e,
0xc1)

lbuf = [0,0,0,0]    #LED Buffer
data = 0
data_sum = 0
count = 0

# 7SEG LED serial convert
def shiftOut(data):
    buf = bytearray(2)
    buf[0] = (data >> 8) & 0xff
    buf[1] = data & 0xff
    spi.write(buf)
    d4.value(1)
    d4.value(0)

# BCD convert
def disp(data):
    lbuf[0] = 0xc
    lbuf[1] = int((data / 10) % 10)
    lbuf[2] = int((data / 100) % 10)
    lbuf[3] = int((data / 1000) % 10)

# Put 7SEG LED
def ledput(dummy):
    global lbuf, led_n, led_col
    if led_n==2:
        shiftOut((0x7f & ledptn[lbuf[led_n]])<<8 | led_col)
    else:
        shiftOut(ledptn[lbuf[led_n]]<<8 | led_col)
    led_n += 1
    led_col >>= 1
    if led_n > 3:
        led_n = 0
        led_col = 0x0008

# Read thormo sencer & Convert temperature
def measure(dummy):
    global data, data_sum, count
    data_sum += (ad4.read()*0.000235+0.075)/0.01
    count += 1
    if count == 10:
        data = round(data_sum*10,0)
        data_sum = 0
        count = 0
        disp(data)

# Main
ad4 = ADC(Pin(36))
ad4.width(ADC.WIDTH_12BIT)  #Set Accuracy 
ad4.atten(ADC.ATTN_0DB)     #Set Attenuator
tim_5ms = Timer(0)
tim_5ms.init(period=5, mode=Timer.PERIODIC, callback=ledput)
tim_100ms = Timer(1)
tim_100ms.init(period=100, mode=Timer.PERIODIC, callback=measure)

while True:
    pass

