'''
 *category   Micropython application
 *package    LED SOFT ON OFF with Switch
 *author     Ichiro Shirasaka
 *copyright  2017 Ichiro Shirasaka All Rights Reserved
 *version    1.0'''

from machine import Pin, PWM
from machine import Timer
import time

p0 = Pin(0, Pin.IN)     #SW pin
state = False           #SW Check Flag
led = False             #LED ON OFF Flag
ledpwm = 0              #LED PWM Value
tim = Timer(0)          #Timer Interrupt object
pwm2 = PWM(Pin(2))      #LED Pin
pwm2.freq(500)          #PWM frequency = 500Hz

#LED Soft ON OFF
def ledput(timer):
    global led, ledpwm  #Global define
    if led == True:     #check led flag
        if ledpwm < 1004:   #Check PWM max
            ledpwm += 20    #Increase PWM width
    if led == False:
        if ledpwm >= 20:    #Check PWM min
            ledpwm -= 20    #Decrease PWM width
    pwm2.duty(ledpwm)       #Set PWM duty

tim.init(period = 50, mode=Timer.PERIODIC, callback=ledput) #Timer Interrupt 50ms Period

print("***LED ソフトON/OFFプログラム***\n")
while True:
    if state == False:
        if p0.value() == 0:     #SW ON
            led = not led       #LED ON OFF
            state = True
            if led:
                print("LED ON")
            else:
                print("LED OFF")
    elif state == True:
        if p0.value() == 1:     #SW OFF
            state = False

